diff --git a/src/include/access/slru.h b/src/include/access/slru.h
index 3b9986f5664..1a9ac3f1924 100644
--- a/src/include/access/slru.h
+++ b/src/include/access/slru.h
@@ -1,7 +1,7 @@
 /*-------------------------------------------------------------------------
  *
  * slru.h
- *		Buffering for transaction status logfiles
+ *		Simple LRU buffering for transaction status logfiles
  *
  * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
  * Portions Copyright (c) 1994, Regents of the University of California
@@ -14,34 +14,10 @@
 #define SLRU_H
 
 #include "access/xlogdefs.h"
-#include "catalog/pg_tablespace_d.h"
-#include "storage/buf.h"
+
 #include "storage/lwlock.h"
-#include "storage/smgr.h"
 #include "storage/sync.h"
 
-/* Pseudo database ID used for SLRU data. */
-#define SLRU_DB_ID 9
-
-/* Pseudo relation IDs used by each cache. */
-#define SLRU_CLOG_REL_ID 0
-#define SLRU_MULTIXACT_OFFSET_REL_ID 1
-#define SLRU_MULTIXACT_MEMBER_REL_ID 2
-#define SLRU_SUBTRANS_REL_ID 3
-#define SLRU_SERIAL_REL_ID 4
-#define SLRU_COMMITTS_REL_ID 5
-#define SLRU_NOTIFY_REL_ID 6
-#define SLRU_NUM_RELS 7
-
-typedef bool (*SlruPagePrecedesFunction) (int, int);
-
-static inline RelFileLocator
-SlruRelFileLocator(RelFileNumber relFileNumber)
-{
-	RelFileLocator rlocator = {DEFAULTTABLESPACE_OID, SLRU_DB_ID, relFileNumber};
-	return rlocator;
-}
-
 
 /*
  * Define SLRU segment size.  A page is the same BLCKSZ as is used everywhere
@@ -58,54 +34,154 @@ SlruRelFileLocator(RelFileNumber relFileNumber)
  */
 #define SLRU_PAGES_PER_SEGMENT	32
 
+
+/*
+ * After we moved the built in SLRU components to the buffer cache, we still
+ * want to support custom SLRU extensions. This internal index is used for the
+ * statistics system to differentiate between non-relational components in nrel.c
+ * and user defined SLRUs. There are currently 7 enumerated non relational components, 
+ * and we use 0 for an invalid id.
+ * hence we use the value 8.
+ */
+#define SLRU_OTHER_ID 8 
+
+/*
+ * Page status codes.  Note that these do not include the "dirty" bit.
+ * page_dirty can be true only in the VALID or WRITE_IN_PROGRESS states;
+ * in the latter case it implies that the page has been re-dirtied since
+ * the write started.
+ */
+typedef enum
+{
+	SLRU_PAGE_EMPTY,			/* buffer is not in use */
+	SLRU_PAGE_READ_IN_PROGRESS, /* page is being read in */
+	SLRU_PAGE_VALID,			/* page is valid and not being written */
+	SLRU_PAGE_WRITE_IN_PROGRESS /* page is being written out */
+} SlruPageStatus;
+
+/*
+ * Shared-memory state
+ */
+typedef struct SlruSharedData
+{
+	LWLock	   *ControlLock;
+
+	/* Number of buffers managed by this SLRU structure */
+	int			num_slots;
+
+	/*
+	 * Arrays holding info for each buffer slot.  Page number is undefined
+	 * when status is EMPTY, as is page_lru_count.
+	 */
+	char	  **page_buffer;
+	SlruPageStatus *page_status;
+	bool	   *page_dirty;
+	int		   *page_number;
+	int		   *page_lru_count;
+	LWLockPadded *buffer_locks;
+
+	/*
+	 * Optional array of WAL flush LSNs associated with entries in the SLRU
+	 * pages.  If not zero/NULL, we must flush WAL before writing pages (true
+	 * for pg_xact, false for multixact, pg_subtrans, pg_notify).  group_lsn[]
+	 * has lsn_groups_per_page entries per buffer slot, each containing the
+	 * highest LSN known for a contiguous group of SLRU entries on that slot's
+	 * page.
+	 */
+	XLogRecPtr *group_lsn;
+	int			lsn_groups_per_page;
+
+	/*----------
+	 * We mark a page "most recently used" by setting
+	 *		page_lru_count[slotno] = ++cur_lru_count;
+	 * The oldest page is therefore the one with the highest value of
+	 *		cur_lru_count - page_lru_count[slotno]
+	 * The counts will eventually wrap around, but this calculation still
+	 * works as long as no page's age exceeds INT_MAX counts.
+	 *----------
+	 */
+	int			cur_lru_count;
+
+	/*
+	 * latest_page_number is the page number of the current end of the log;
+	 * this is not critical data, since we use it only to avoid swapping out
+	 * the latest page.
+	 */
+	int			latest_page_number;
+
+	/* SLRU's index for statistics purposes (might not be unique) */
+	int			slru_stats_idx;
+} SlruSharedData;
+
+typedef SlruSharedData *SlruShared;
+
+/*
+ * SlruCtlData is an unshared structure that points to the active information
+ * in shared memory.
+ */
+typedef struct SlruCtlData
+{
+	SlruShared	shared;
+
+	/*
+	 * Which sync handler function to use when handing sync requests over to
+	 * the checkpointer.  SYNC_HANDLER_NONE to disable fsync (eg pg_notify).
+	 */
+	SyncRequestHandler sync_handler;
+
+	/*
+	 * Decide whether a page is "older" for truncation and as a hint for
+	 * evicting pages in LRU order.  Return true if every entry of the first
+	 * argument is older than every entry of the second argument.  Note that
+	 * !PagePrecedes(a,b) && !PagePrecedes(b,a) need not imply a==b; it also
+	 * arises when some entries are older and some are not.  For SLRUs using
+	 * SimpleLruTruncate(), this must use modular arithmetic.  (For others,
+	 * the behavior of this callback has no functional implications.)  Use
+	 * SlruPagePrecedesUnitTests() in SLRUs meeting its criteria.
+	 */
+	bool		(*PagePrecedes) (int, int);
+
+	/*
+	 * Dir is set during SimpleLruInit and does not change thereafter. Since
+	 * it's always the same, it doesn't need to be in shared memory.
+	 */
+	char		Dir[64];
+} SlruCtlData;
+
+typedef SlruCtlData *SlruCtl;
+
+
+extern Size SimpleLruShmemSize(int nslots, int nlsns);
+extern void SimpleLruInit(SlruCtl ctl, const char *name, int nslots, int nlsns,
+						  LWLock *ctllock, const char *subdir, int tranche_id,
+						  SyncRequestHandler sync_handler);
+extern int	SimpleLruZeroPage(SlruCtl ctl, int pageno);
+extern int	SimpleLruReadPage(SlruCtl ctl, int pageno, bool write_ok,
+							  TransactionId xid);
+extern int	SimpleLruReadPage_ReadOnly(SlruCtl ctl, int pageno,
+									   TransactionId xid);
+extern void SimpleLruWritePage(SlruCtl ctl, int slotno);
+extern void SimpleLruWriteAll(SlruCtl ctl, bool allow_redirtied);
 #ifdef USE_ASSERT_CHECKING
-extern void SlruPagePrecedesUnitTests(SlruPagePrecedesFunction PagePrecedes,
-									  int per_page);
+extern void SlruPagePrecedesUnitTests(SlruCtl ctl, int per_page);
 #else
 #define SlruPagePrecedesUnitTests(ctl, per_page) do {} while (0)
 #endif
-extern void SimpleLruTruncate(Oid rel_id, SlruPagePrecedesFunction PagePrecedes,
-							  int cutoffPage);
-extern bool SimpleLruDoesPhysicalPageExist(Oid rel_id, int pageno);
+extern void SimpleLruTruncate(SlruCtl ctl, int cutoffPage);
+extern bool SimpleLruDoesPhysicalPageExist(SlruCtl ctl, int pageno);
 
-typedef bool (*SlruScanCallback) (Oid rel_id,
-								  SlruPagePrecedesFunction PagePrecedes,
-								  char *filename, int segpage,
+typedef bool (*SlruScanCallback) (SlruCtl ctl, char *filename, int segpage,
 								  void *data);
-extern bool SlruScanDirectory(Oid rel_id, SlruPagePrecedesFunction PagePrecedes,
-							  SlruScanCallback callback, void *data);
-extern void SlruDeleteSegment(Oid rel_id, int segno);
+extern bool SlruScanDirectory(SlruCtl ctl, SlruScanCallback callback, void *data);
+extern void SlruDeleteSegment(SlruCtl ctl, int segno);
+
+extern int	SlruSyncFileTag(SlruCtl ctl, const FileTag *ftag, char *path);
 
 /* SlruScanDirectory public callbacks */
-extern bool SlruScanDirCbReportPresence(Oid rel_id,
-										SlruPagePrecedesFunction PagePrecedes,
-										char *filename,
+extern bool SlruScanDirCbReportPresence(SlruCtl ctl, char *filename,
 										int segpage, void *data);
-extern bool SlruScanDirCbDeleteAll(Oid rel_id, SlruPagePrecedesFunction PagePrecedes,
-								   char *filename, int segpage,
+extern bool SlruScanDirCbDeleteAll(SlruCtl ctl, char *filename, int segpage,
 								   void *data);
 
-extern void CheckPointSLRU(void);
-
-/* Buffer access */
-extern Buffer ReadSlruBuffer(Oid rel_id, int pageno);
-extern Buffer ZeroSlruBuffer(Oid rel_id, int pageno);
-
-/* Interfaces use by stats view */
-extern Oid SlruRelIdByName(const char *name);
-extern const char *SlruName(Oid rel_id);
-
-/* Sync callback */
-extern int	slrusyncfiletag(const FileTag *ftag, char *path);
-
-/* SMGR callbacks */
-extern void slruopen(SMgrRelation reln);
-extern void slruclose(SMgrRelation reln, ForkNumber forknum);
-extern void slruread(SMgrRelation reln, ForkNumber forknum,
-					 BlockNumber blocknum, char *buffer);
-extern void slruwrite(SMgrRelation reln, ForkNumber forknum,
-					  BlockNumber blocknum, char *buffer, bool skipFsync);
-extern void slruwriteback(SMgrRelation reln, ForkNumber forknum,
-						  BlockNumber blocknum, BlockNumber nblocks);
 
 #endif							/* SLRU_H */
diff --git a/src/include/pgstat.h b/src/include/pgstat.h
index f7ee92b238f..eee7319aa94 100644
--- a/src/include/pgstat.h
+++ b/src/include/pgstat.h
@@ -682,8 +682,8 @@ extern void pgstat_count_slru_page_read(int slru_idx);
 extern void pgstat_count_slru_page_written(int slru_idx);
 extern void pgstat_count_slru_page_exists(int slru_idx);
 extern void pgstat_count_slru_flush(int slru_idx);
-extern void pgstat_count_slru_truncate(int slru_idx);
-extern const char *pgstat_get_slru_name(int slru_idx);
+extern void pgstat_count_slru_truncate(int nrel_idx);
+extern const char *pgstat_get_nrel_name(int slru_idx);
 extern int	pgstat_get_slru_index(const char *name);
 extern PgStat_SLRUStats *pgstat_fetch_slru(void);
 
diff --git a/src/include/storage/smgr.h b/src/include/storage/smgr.h
index e36aace0bda..2c83f7b1b40 100644
--- a/src/include/storage/smgr.h
+++ b/src/include/storage/smgr.h
@@ -73,8 +73,8 @@ typedef struct SMgrRelationData
 	 * for slru.c; we'll just cache one File for now.
 	 * XXX Unionize with md stuff somehow so we don't waste space
 	 */
-	int			slru_file_segment;
-	File		slru_file;
+	int			nrel_file_segment;
+	File		nrel_file;
 
 	/* if unowned, list link in list of all unowned SMgrRelations */
 	dlist_node	node;
diff --git a/src/include/storage/sync.h b/src/include/storage/sync.h
index eac5cbf86b3..69f4035847d 100644
--- a/src/include/storage/sync.h
+++ b/src/include/storage/sync.h
@@ -35,7 +35,8 @@ typedef enum SyncRequestType
 typedef enum SyncRequestHandler
 {
 	SYNC_HANDLER_MD = 0,
-	SYNC_HANDLER_SLRU
+	SYNC_HANDLER_NREL,
+	SYNC_HANDLER_NONE
 } SyncRequestHandler;
 
 /*
diff --git a/src/include/utils/memutils.h b/src/include/utils/memutils.h
index c4b1a6f08de..21640d62a64 100644
--- a/src/include/utils/memutils.h
+++ b/src/include/utils/memutils.h
@@ -62,7 +62,6 @@ extern PGDLLIMPORT MemoryContext CacheMemoryContext;
 extern PGDLLIMPORT MemoryContext MessageContext;
 extern PGDLLIMPORT MemoryContext TopTransactionContext;
 extern PGDLLIMPORT MemoryContext CurTransactionContext;
-extern PGDLLIMPORT MemoryContext SlruMemoryContext;
 
 /* This is a transient link to the active portal's memory context: */
 extern PGDLLIMPORT MemoryContext PortalContext;
diff --git a/src/include/utils/pgstat_internal.h b/src/include/utils/pgstat_internal.h
index 425678daa3d..42f418ba6dc 100644
--- a/src/include/utils/pgstat_internal.h
+++ b/src/include/utils/pgstat_internal.h
@@ -14,6 +14,7 @@
 #define PGSTAT_INTERNAL_H
 
 
+#include "access/nrel.h"
 #include "access/slru.h"
 #include "common/hashfn.h"
 #include "lib/dshash.h"
@@ -323,7 +324,7 @@ typedef struct PgStatShared_SLRU
 {
 	/* lock protects ->stats */
 	LWLock		lock;
-	PgStat_SLRUStats stats[SLRU_NUM_RELS];
+	PgStat_SLRUStats stats[NREL_NUM_RELS];
 } PgStatShared_SLRU;
 
 typedef struct PgStatShared_Wal
@@ -435,7 +436,7 @@ typedef struct PgStat_Snapshot
 
 	PgStat_IO	io;
 
-	PgStat_SLRUStats slru[SLRU_NUM_RELS];
+	PgStat_SLRUStats slru[NREL_NUM_RELS];
 
 	PgStat_WalStats wal;
 
-- 
2.40.1

